// This header file contains the functions to manipulate     c7intfun.h
//  integer arrays from chapter 7
//  showarray,getarray,findlargest,sort
#ifndef c7intfun_h
#define c7intfun_h
void showarray(int number[],int from,int to)
{
  Box list[10];
  for (int i=from;i<=to;i++)
  {
	  list[i%10].place(400,50+(i%10)*40);
	  list[i%10].label(i);
	  list[i%10].say(number[i]);
  }
}
void getarray(int number[],int from,int to)
{
  for (int i=from;i<=to;i++)
  {
    number[i]=ask("Input a number");
  }
}
int findlargest(int number[],int from,int to)
{
 int index;
 int guess;
 guess=from; // Take the first as a guess
 for (index=from;index<=to;index++)
  {
    if(number[guess]<number[index])
    {
		 guess=index; // change the guess
	 }
  }
  return guess;
}
void sort (int array[],int fromwhere,int towhere)
{
  int largest,temp;
  // loop decreasing "last" each time.
  for (int last=towhere;last>fromwhere;last--)
  {
    // find largest from beginnig to "last"
    largest=findlargest(array,fromwhere,last);
    // switch largest with the "last"
    temp=array[largest];
    array[largest]=array[last];
    array[last]=temp;
  }
}
void recsort (int array[],int fromwhere,int towhere)
{
  // this is a recursive version of sort:
  int largest,temp;
    int last;
    last=towhere;
    // check if sort is not complete:
    if(fromwhere<=towhere)
    {
    // find largest from beginnig to "last"
    largest=findlargest(array,fromwhere,last);
    // switch largest with the "last"
    temp=array[largest];
    array[largest]=array[last];
    array[last]=temp;
    // sort the remaining array
    recsort(array,fromwhere,last-1);
    }
}
#endif

// end


