#include "franca.h"
#ifndef RUNNER_H
#define RUNNER_H 
//const int armsize=20,armwidth=6;
class runner: public athlete
{
  protected:
   void stepleft(float);
   void stepright(float);
  public:
   void run();
};
void runner::stepright(float time)
{
   Clock any;
   erase();
   leftarm.resize(armsize/2,armwidth);
   leftarm.place((x-(armsize+armwidth)/2.),y-armsize/4);
   rightleg.resize(armsize/2,armwidth);
   rightleg.place(x+(armsize/2.-armwidth),y+3*armsize/4);
   show();
   any.wait(time);
}
void runner::stepleft(float time)
{
   Clock any;
   erase();
   rightarm.resize(armsize/2,armwidth);
   rightarm.place(x+(armsize+armwidth)/2,y-armsize/4);
   leftleg.resize(armsize/2,armwidth);
   leftleg.place(x-(armsize/2-armwidth),y+3*armsize/4);
   show();
   any.wait(time);
}
void runner::run()
{
   stepleft(.1);
   erase();
   ready(.1);
   stepright(.1);
   erase();
   ready(.1);
   erase();
   place(x+1,y);
   ready(0.);
}
class skater:public runner
{
 public:
  void run();
};
void skater::run()
{
  for(int i=1;i<=5;i++)// move 5 steps
  { // standing on left foot
    stepleft(.1);
    erase();
    place(x+1,y);
    ready(0.);
  }
  for(i=1;i<=5;i++)// move 5 steps
  { // standing on right foot
    stepright(.1);
    erase();
    place(x+1,y);
  }
  ready(0.);
}
#endif


//


