#ifndef SATELLIT_H
#define SATELLIT_H
#include "franca.h"
#include "math.h"
class satellite: public Circle
{
  protected:
   float xplanet,yplanet;
   float radius,omega,wspeed;
   void polarxy(float r,float teta,float x0,
	     float y0,float &x,float &y);
  public:
   satellite();
   void center(float x,float y);
   void dist(float rad);
   void angle(float ang);
   void speed(float ws);
   void move();
   void center(satellite &another);
};
void satellite::polarxy(float r,float teta,float x0,
	     float y0,float &x,float &y)
{
 x=r*cos(teta)+x0;
 y=r*sin(teta)+y0;
}
satellite::satellite()
{
   color(2);
   xplanet=yplanet=0;
   radius=0;
   omega=wspeed=0;
}
void satellite::center(float xc,float yc)
{
   xplanet=xc;
   yplanet=yc;
}
void satellite::center(satellite &another)
{
   center(another.x,another.y);
}
void satellite::dist(float rad)
{
   radius=rad;
}
void satellite::angle(float ang)
{
   omega=ang;
}
void satellite::speed(float ws)
{
   wspeed=ws;
}
void satellite::move()
{ 
   omega=omega+wspeed;
   polarxy(radius,omega,xplanet,yplanet,x,y);
}
#endif   


// END OF PROGRAM

