#ifndef TFILE_H
#define TFILE_H
#include "nofranca.h"
#include <fstream.h>
#include <string.h>
			     // c8tfile.h
// This class manipulates a text file			     // This version implements the
//       as an object.
// A constructor automatically opens
//      the file.
// The display member function
//        handles the printing of
//        data.
// The read member function reads data
//      from disk
// The find member function locates a
//      record in the file.
// Functions input and write can be used
//      to append data to the file.
// It is hoped that this may be a base class
//      for deriving any kind of textfile class
//      where the record identification is an
//      alphanumeric sequence in the beginning
//      of each line.
// note
// This class uses cout and cin
// either iostream.h must be included
// or some other header that defines
// cin and cout objets.
inline int fileopen(fstream& datafile)
{
  int yesopen=1;
   #ifdef Microsoft
       yesopen=datafile.is_open();
   #endif
   #ifdef Borland
       yesopen=!(datafile==NULL);
   #endif
  return yesopen;
}
class textfile
{
  protected:
   fstream data;
   char datafile[40];
   int filemode;
  public:
   char id[40];
   textfile();
   textfile(char filename[],int mode=ios::in|ios::app|ios::nocreate);
   ~textfile();
   void display();
   virtual int read();
   int find(char id[]);
   int input();
   void write();
};
textfile::textfile()
{
   askwords(datafile,40,"enter the file name:");
   filemode=ios::in|ios::app|ios::nocreate;
   data.open(datafile,filemode);
   // Check if file opens
	if(fileopen(data)==0)
   {
      if(yesno("File not open, create?"))
      {
		 filemode=ios::out;
		 data.open(datafile,filemode);
		 if(fileopen(data)==0)
		 {
          yesno("Sorry, file does not open!");
			 exit(0);
		 }
	    else;
      }
      else exit(0);
   }
}
textfile::textfile(char filename[],int mode)
{
   if(sizeof (datafile)>strlen(filename))strcpy(datafile,filename);
   data.open(datafile,mode);
   filemode=mode;
   if(fileopen(data)==0)
   {
      yesno("Error in opening, will you check?");
      exit(0);
   }
}
textfile::~textfile()
{
   data.close();
}
void textfile::display()
{
}
int textfile::read()
{
//  This function reads the next record from the file
   data>>id;
   if (data.eof()) return 0;
   return 1;
}
int textfile::find(char idnumber[])
{
    data.close();
    data.open(datafile,filemode);
    if(fileopen(data)==0)
    {
      yesno("Failed to reopen for find, will you check?");
      exit(0);
    }
    for(;;)
    {
     if(data.eof())break;
     if(strcmp(id,idnumber)!=0)  read();// virtual read!
     else return 1;
    }
    data.close();
    data.open(datafile,filemode);
    return 0;
}
int textfile::input()
{
   askwords(id,40,"Enter id code");
   if(id[0]=='0') return 0;
   return 1;
}
void textfile::write()
{
   data.close();
   data.open(datafile,ios::app);
   if(fileopen(data)==0)
   {
     yesno("Failed reopen for append, will you check?");
     return;
   }
   data<<endl<<id<<' ';
   data.close();
   data.open(datafile,filemode);
}
#endif
//end


